; 
include \masm32\include\masm32rt.inc

IDC_EDIT equ 100
; 
    .data
      hInst     dd 0
      hwndEdit  dd 0
      pBuffer   dd 0
      cbBuffer  dd 0
    .code
; 

DllMain proc hinstDLL:HINSTANCE, fdwReason:DWORD, lpvReserved:LPVOID

    SWITCH fdwReason

      CASE DLL_PROCESS_ATTACH

        push hinstDLL
        pop hInst
        mov eax, TRUE

      CASE DLL_PROCESS_DETACH
      CASE DLL_THREAD_ATTACH
      CASE DLL_THREAD_DETACH

    ENDSW

    ret

DllMain endp

; 

DlgProc proc hDlg:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL rc:RECT

    SWITCH uMsg

      CASE WM_INITDIALOG

        invoke GetDlgItem, hDlg, IDC_EDIT
        mov hwndEdit, eax

      CASE WM_COMMAND

        SWITCH wParam

          CASE IDCANCEL

            ;---------------------------------------------
            ; Store the edit control text in the caller's
            ; buffer and close the dialog.
            ;---------------------------------------------

            invoke GetDlgItemText, hDlg, IDC_EDIT, pBuffer, cbBuffer
            invoke EndDialog, hDlg, NULL

        ENDSW

      CASE WM_CLOSE

        ;---------------------------------------------
        ; Store the edit control text in the caller's
        ; buffer and close the dialog.
        ;---------------------------------------------

        invoke GetDlgItemText, hDlg, IDC_EDIT, pBuffer, cbBuffer
        invoke EndDialog, hDlg, NULL

    ENDSW

    return 0

DlgProc endp

; 

GetInput proc pBuff:DWORD, cbBuff:DWORD

    ;------------------------------------------------------------
    ; Save the buffer address and size to module-level variables
    ; so DlgProc can use them to store the edit control text in
    ; the caller's buffer.
    ;------------------------------------------------------------

    push pBuff
    pop pBuffer
    push cbBuff
    pop cbBuffer

    Dialog  "Test", \
            "Courier New",10, \
            WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, \
            1, \
            0,0,80,40, \
            1024
    DlgEdit ES_AUTOHSCROLL or WS_BORDER,10,10,58,10,IDC_EDIT

    CallModalDialog hInst, 0, DlgProc, NULL

    ret

GetInput endp

; 
end DllMain

